]> git.madduck.net Git - code/myrepos.git/blobdiff - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

need to manally reap children since it manually forks now
[code/myrepos.git] / mr
diff --git a/mr b/mr
index a3d3a45668a9610fd134ae41cfb5ba850ed9de72..76c629ca1ddd1c2ceaa147aa6125a5f9b9b9f666 100755 (executable)
--- a/mr
+++ b/mr
@@ -157,6 +157,12 @@ about exactly which repositories failed and were skipped, if any.
 Just operate on the repository for the current directory, do not 
 recurse into deeper repositories.
 
+=item -j number
+
+Run the specified number of jobs in parallel. This can greatly speed up
+operations such as updates. It is not recommended for interactive
+operations.
+
 =back
 
 =head1 FILES
@@ -255,6 +261,13 @@ use warnings;
 use strict;
 use Getopt::Long;
 use Cwd qw(getcwd abs_path);
+use POSIX "WNOHANG";
+use constant {
+       OK => 0,
+       FAILED => 1,
+       SKIPPED => 2,
+       ABORT => 3,
+};
 
 $SIG{INT}=sub {
        print STDERR "mr: interrupted\n";
@@ -267,6 +280,7 @@ my $directory=getcwd();
 my $verbose=0;
 my $stats=0;
 my $no_recurse=0;
+my $jobs=1;
 my %config;
 my %configfiles;
 my %knownactions;
@@ -279,6 +293,7 @@ my $result=GetOptions(
        "v|verbose" => \$verbose,
        "s|stats" => \$stats,
        "n|no-recurse" => \$no_recurse,
+       "j|jobs=i" => \$jobs,
 );
 if (! $result || @ARGV < 1) {
        die("Usage: mr [-d directory] action [params ...]\n".
@@ -292,17 +307,17 @@ if (! $result || @ARGV < 1) {
 if ($ENV{MR_CONFIG} !~ /^\//) {
        $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
 }
+# Try to set MR_PATH to the path to the program.
+eval {
+       use FindBin qw($Bin $Script);
+       $ENV{MR_PATH}=$Bin."/".$Script;
+};
 
 loadconfig(\*DATA);
 loadconfig($ENV{MR_CONFIG});
 #use Data::Dumper;
 #print Dumper(\%config);
 
-eval {
-       use FindBin qw($Bin $Script);
-       $ENV{MR_PATH}=$Bin."/".$Script;
-};
-
 # alias expansion and command stemming
 my $action=shift @ARGV;
 if (exists $alias{$action}) {
@@ -418,10 +433,40 @@ if (! @repos) {
        $nochdir=1;
 }
 
-my (@failed, @ok, @skipped);
-foreach my $repo (@repos) {
-       action($action, @$repo);
+# run the action on each repository and print stats
+my (@ok, @failed, @skipped);
+if ($jobs > 1) {
+       mrs(@repos);
+}
+else {
+       foreach my $repo (@repos) {
+               record($repo, action($action, @$repo));
+               print "\n";
+       }
+}
+if (! @ok && ! @failed && ! @skipped) {
+       die "mr $action: no repositories found to work on\n";
+}
+print "mr $action: finished (".join("; ",
+       showstat($#ok+1, "ok", "ok"),
+       showstat($#failed+1, "failed", "failed"),
+       showstat($#skipped+1, "skipped", "skipped"),
+).")\n";
+if ($stats) {
+       if (@skipped) {
+               print "mr $action: (skipped: ".join(" ", @skipped).")\n";
+       }
+       if (@failed) {
+               print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
+       }
+}
+if (@failed) {
+       exit 1;
+}
+elsif (! @ok && @skipped) {
+       exit 1;
 }
+exit 0;
 
 sub action { #{{{
        my ($action, $dir, $topdir, $subdir) = @_;
@@ -433,15 +478,14 @@ sub action { #{{{
        if ($action eq 'checkout') {
                if (-d $dir) {
                        print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
-                       push @skipped, $dir;
-                       return;
+                       return SKIPPED;
                }
 
                $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
 
                if (! -d $dir) {
                        print "mr $action: creating parent directory $dir\n" if $verbose;
-                       my $ret=system("mkdir", "-p", $dir);
+                       system("mkdir", "-p", $dir);
                }
        }
        elsif ($action eq 'update') {
@@ -460,27 +504,26 @@ sub action { #{{{
                if ($ret != 0) {
                        if (($? & 127) == 2) {
                                print STDERR "mr $action: interrupted\n";
-                               exit 2;
+                               return ABORT;
                        }
                        elsif ($? & 127) {
                                print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
-                               exit 1;
+                               return ABORT;
                        }
                }
                if ($ret >> 8 == 0) {
                        print "mr $action: $dir skipped per config file\n" if $verbose;
-                       push @skipped, $dir;
-                       return;
+                       return SKIPPED;
                }
        }
        
        if (! $nochdir && ! chdir($dir)) {
                print STDERR "mr $action: failed to chdir to $dir: $!\n";
-               push @failed, $dir;
+               return FAILED;
        }
        elsif (! exists $config{$topdir}{$subdir}{$action}) {
                print STDERR "mr $action: no defined $action command for $topdir$subdir, skipping\n";
-               push @skipped, $dir;
+               return SKIPPED;
        }
        else {
                if (! $nochdir) {
@@ -497,31 +540,118 @@ sub action { #{{{
                if ($ret != 0) {
                        if (($? & 127) == 2) {
                                print STDERR "mr $action: interrupted\n";
-                               exit 2;
+                               return ABORT;
                        }
                        elsif ($? & 127) {
                                print STDERR "mr $action: received signal ".($? & 127)."\n";
+                               return ABORT;
                        }
                        print STDERR "mr $action: failed ($ret)\n" if $verbose;
-                       push @failed, $dir;
                        if ($ret >> 8 != 0) {
                                print STDERR "mr $action: command failed\n";
                        }
                        elsif ($ret != 0) {
                                print STDERR "mr $action: command died ($ret)\n";
                        }
+                       return FAILED;
                }
                else {
                        if ($action eq 'checkout' && ! -d $dir) {
                                print STDERR "mr $action: $dir missing after checkout\n";;
-                               push @failed, $dir;
-                               return;
+                               return FAILED;
                        }
 
-                       push @ok, $dir;
+                       return OK;
+               }
+       }
+} #}}}
+
+# run actions on multiple repos, in parallel
+sub mrs { #{{{
+       $| = 1;
+       my @active;
+       my @fhs;
+       my @out;
+       my $running=0;
+       while (@fhs or @repos) {
+               while ($running < $jobs && @repos) {
+                       $running++;
+                       my $repo = shift @repos;
+                       pipe(my $outfh, CHILD_STDOUT);
+                       pipe(my $errfh, CHILD_STDERR);
+                       my $pid;
+                       unless ($pid = fork) {
+                               die "mr $action: cannot fork: $!" unless defined $pid;
+                               open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
+                               open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
+                               close CHILD_STDOUT;
+                               close CHILD_STDERR;
+                               close $outfh;
+                               close $errfh;
+                               exit action($action, @$repo);
+                       }
+                       close CHILD_STDOUT;
+                       close CHILD_STDERR;
+                       push @active, [$pid, $repo];
+                       push @fhs, [$outfh, $errfh];
+                       push @out, ['',     ''];
+               }
+               my ($rin, $rout) = ('','');
+               my $nfound;
+               foreach my $fh (@fhs) {
+                       next unless defined $fh;
+                       vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
+                       vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
                }
+               $nfound = select($rout=$rin, undef, undef, 1);
+               foreach my $channel (0, 1) {
+                       foreach my $i (0..$#fhs) {
+                               next unless defined $fhs[$i];
+                               my $fh = $fhs[$i][$channel];
+                               next unless defined $fh;
+                               if (vec($rout, fileno($fh), 1) == 1) {
+                                       my $r = '';
+                                       if (sysread($fh, $r, 1024) == 0) {
+                                               close($fh);
+                                               $fhs[$i][$channel] = undef;
+                                               if (! defined $fhs[$i][0] &&
+                                                   ! defined $fhs[$i][1]) {
+                                                       waitpid($active[$i][0], 0);
+                                                       print STDOUT $out[$i][0];
+                                                       print STDERR $out[$i][1];
+                                                       print "\n";
+                                                       record($active[$i][1], $? >> 8);
+                                                       splice(@fhs, $i, 1);
+                                                       splice(@active, $i, 1);
+                                                       splice(@out, $i, 1);
+                                                       $running--;
+                                               }
+                                       }
+                                       $out[$i][$channel] .= $r;
+                               }
+                       }
+               }
+       }
+} #}}}
 
-               print "\n";
+sub record { #{{{
+       my $dir=shift()->[0];
+       my $ret=shift;
+
+       if ($ret == OK) {
+               push @ok, $dir;
+       }
+       elsif ($ret == FAILED) {
+               push @failed, $dir;
+       }
+       elsif ($ret == SKIPPED) {
+               push @skipped, $dir;
+       }
+       elsif ($ret == ABORT) {
+               exit 1;
+       }
+       else {
+               die "unknown exit status $ret";
        }
 } #}}}
 
@@ -534,29 +664,6 @@ sub showstat { #{{{
        }
        return;
 } #}}}
-if (! @ok && ! @failed && ! @skipped) {
-       die "mr $action: no repositories found to work on\n";
-}
-print "mr $action: finished (".join("; ",
-       showstat($#ok+1, "ok", "ok"),
-       showstat($#failed+1, "failed", "failed"),
-       showstat($#skipped+1, "skipped", "skipped"),
-).")\n";
-if ($stats) {
-       if (@skipped) {
-               print "mr $action: (skipped: ".join(" ", @skipped).")\n";
-       }
-       if (@failed) {
-               print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
-       }
-}
-if (@failed) {
-       exit 1;
-}
-elsif (! @ok && @skipped) {
-       exit 1;
-}
-exit 0;
 
 my %loaded;
 sub loadconfig { #{{{
@@ -833,7 +940,7 @@ status =
        elif [ -d "$MR_REPO"/CVS ]; then
                cvs status "$@"
        elif [ -d "$MR_REPO"/.hg ]; then
-               hg status "$@" 
+               hg status "$@"
        else
                error "unknown repo type"
        fi
@@ -847,7 +954,7 @@ commit =
        elif [ -d "$MR_REPO"/CVS ]; then
                cvs commit "$@"
        elif [ -d "$MR_REPO"/.hg ]; then
-               hg commit -m "$@" && hg push 
+               hg commit -m "$@" && hg push
        else
                error "unknown repo type"
        fi